<template>
  <v-app class="diseaseDynamicReport">
    <v-container style="padding: 20px">
      <div class="diseaseDynamicReport__title">
        <h1>Отчёт о динамике заболеваемости</h1>
      </div>
      <div class="diseaseDynamicReport__subtitle">
        <h2>Нажмите для создания отчёта</h2>
      </div>

      <v-dialog v-model="dialogReport" max-width="500px">
        <template v-slot:activator="{ on, attrs }">
          <v-btn class="diseaseDynamicReport__btn" v-bind="attrs" v-on="on" style="margin-right: auto">Создать</v-btn>
        </template>
        <v-card>
          <v-card-title>
            <span class="text-h5">{{ "Получить отчёт" }}</span>
          </v-card-title>

          <v-card-text>
            <v-container>
              <v-row>
                <v-col cols="12" sm="6" md="12">
                  <v-text-field v-model="dialogItem.year" item-value="year" label="Год"></v-text-field>
                </v-col>
              </v-row>
            </v-container>
          </v-card-text>

          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="#AFFFCF" @click="close">
              Закрыть
            </v-btn>
            <v-btn color="#AFFFCF" @click="requestReport">
              Получить отчет
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>

      <div class="diseaseDynamicReport__subsubTitle">
        <h2>Общее количество больных обслуженных за год</h2>
      </div>
      <v-data-table
          :headers="headers"
          :items="patientPeriod"
          class="diseaseDynamicReport_table"
      >
        <template v-slot:top>
          <v-toolbar flat>
            <v-spacer></v-spacer>
            <v-dialog v-model="dialogPatient" max-width="500px">
              <template v-slot:activator="{ on, attrs }">
                <v-btn color="primary" dark class="mb-2" v-bind="attrs" v-on="on">Рассчитать количество больных за год</v-btn>
              </template>

              <v-card>
                <v-card-text>
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="6" md="12">
                        <v-text-field v-model="dialogItemPatient.year" item-value="year" label="Год"></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-card-text>

                <v-card-actions>
                  <v-spacer></v-spacer>
                  <v-btn color="#AFFFCF" @click="close">Закрыть</v-btn>
                  <v-btn color="#AFFFCF" @click="savePatient">Сохранить</v-btn>
                </v-card-actions>
              </v-card>
            </v-dialog>
          </v-toolbar>
        </template>
      </v-data-table>

      <template>
        <span>Общее количество больных:  </span>{{ this.patientPeriod.length }}
      </template>
    </v-container>
  </v-app>
</template>

<script>
import axios from "axios";

export default {
  name: "DiseaseDynamicReport",
  data() {
    return {
      dialogReport: false,
      dialogPatient: false,
      patientPeriod: [],
      dialogItem: {
        year: 'YYYY',
      },

      dialogItemPatient: {
        year: 'YYYY'
      },

      checker: false,
      pdfsrc: '',

      headers: [
        {
          text: 'Фамилия',
          value: 'surname',
          sortable: false
        },
        {
          text: 'Имя',
          value: 'name',
          sortable: false
        },
        {
          text: 'Отчество',
          value: 'fatherName',
          sortable: false
        },
      ],
    }
  },

  created() {
    if (!localStorage.getItem('user')) {
      this.$router.push('/app')
    }
  },

  methods: {
    async fetchReport(item) {
      axios
          .post(this.$root.globalVar + '/reports/disease_dynamics_report/' + item.year, {
            year: item.year
          }, {
            responseType: "blob"
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })
          .then(response => {
            console.log("Success", response);
            const blob = new Blob([response.data], {type: 'application/pdf'});
            console.log(blob)
            const objectUrl = URL.createObjectURL(blob);
            this.pdfsrc = objectUrl;
            console.log(objectUrl);
            window.open(objectUrl)
            this.checker = true;
          })
    },

    async fetchPatient(item) {
      axios
          .get(this.$root.globalVar + '/patient/period/' + item.year)
          .then(response => {
            this.patientPeriod = response.data
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })
    },

    close() {
      this.dialogReport = false
      this.dialogPatient = false
    },

    savePatient() {
      this.fetchPatient(this.dialogItemPatient)
      this.close()
    },

    requestReport() {
      if (this.dialogItem.year === '') {
        alert('Ошибка! Подробности: введите данные.')
        throw new Error("Ошибка! Подробности: введите данные.");
      }
      this.fetchReport(this.dialogItem)
      this.close()
    }
  }
}
</script>

<style lang="scss" scoped>
.diseaseDynamicReport {
  &__title {
    text-align: center;
    margin: 60px 0 30px 0;
  }

  &__subtitle {
    margin: 0 0 20px 50px;
  }

  &__btn {
    margin-left: 50px;
  }

  &__subsubTitle {
    margin: 50px 0 30px 0;
    text-align: center;
  }
}
</style>